/**
 * @author THINKER
 */

var defaultPath = window.location.pathname;


function initPage(){
	
	$("<div class='tempPage'></div>").appendTo('#container');
	
	var $spinner = $("<div class='spinner'><img src='img/spinner.gif' alt=''/><h2>loading.....</h2></div>");
	
	var containerHeight = 	window.innerHeight;
	
	$spinner.css("top",containerHeight/2 );
	$spinner.appendTo("#container");
	
	$('[data-div-type="page"]').remove();
	
	checkHeight();
	
	
}


function checkHeight(){
	
	var pageHeight = window.innerHeight -  ($(".header").height()+$(".nav").height() + 10 );
	
	$(".currentPage, .tempPage").height(pageHeight);
}


function loadPage(transType, targetPage){
	
	
	$(".currentPage").attr("data-change-type", transType);

	$(".spinner").show();
	
	var pstate = {toPage:targetPage, type:transType};
	window.history.pushState(pstate,"",targetPage);
	
	if(targetPage.indexOf("#")== 0){
		console.log("call Internal ");
		loadInternalPage(targetPage);
	}else{	
		loadAjaxPage(targetPage);
	}
	
}

window.addEventListener("popstate", function(e) {


	if(!event.state){		
		var tempState = {toPage:location.pathname, type:'fade'};
		window.history.replaceState(tempState,"", tempState.toPage);
		return;
	}

	var beforePage = event.state.toPage;
	var changeType = $(".tempPage").attr("data-change-type");
	var stateType = event.state.type;
	
	if(changeType.lastIndexOf("-back") < 0){
		changeType += "-back"; 
	}
	
	$(".currentPage").attr("data-change-type", changeType);
	
	if(beforePage.indexOf("#")== 0){
		loadInternalPage(event.state.toPage, function() {
		$(".tempPage").attr("data-change-type", stateType); });
	}else { 
		loadAjaxPage(event.state.toPage, function() {
		$(".tempPage").attr("data-change-type", stateType); });
	}	
});




function loadAjaxPage(targetPage, backFlag){

	$(".tempPage").load( targetPage +" .currentPage > *", 
	  function(){
	  	
	  	var jsFileURL = "js/"+targetPage.substr(0,targetPage.lastIndexOf("."))+".js";
	  	
	  	$.getScript(jsFileURL)
	  		.done(function(data, textStatus){
							if(textStatus == 'success' && pageBefore){
								pageBefore();
							}
	  					transitionPage(textStatus, backFlag);				
				}) 
				.fail( function(){ transitionPage('fail', backFlag); } );
	  });
}



function loadInternalPage(targetPage, backFlag){
	
	$(".tempPage").load( defaultPath + " "+ targetPage+" > *", 
	  function(){  
		  var jsFileURL = "js/"+targetPage.substr(1)+".js";
			
			$.getScript(jsFileURL)
			.done(function(data, textStatus){
						if(textStatus == 'success' && pageBefore){
							pageBefore();
						}
	  				transitionPage(textStatus, backFlag);				
			})
			.fail( function(){ transitionPage('fail', backFlag); } );
			
		});	  	
}

function transitionPage(textStatus, backFlag){
	
	console.log(textStatus);
	
	var $currentPage = $(".currentPage");
	var $tempPage = $(".tempPage");
	
	var changeType = $currentPage.attr("data-change-type");
	
	$currentPage.addClass(changeType+"-out");
	$tempPage.addClass(changeType+"-in");
	
	
	$tempPage.one("webkitAnimationEnd", function( ) {
		$currentPage.html("").attr("class", "tempPage");
		$tempPage.attr("class","currentPage");
		if(backFlag){
			backFlag();
		}
		$(".spinner").hide();
		
		if(textStatus=='success' && pageAfter){
			pageAfter();
		}
		
	});
	
}

